 
"""
      Yasuharu Okamoto, 2018.11, 2019.03
 
"""
import csv
import pystan
import pickle
import matplotlib.pyplot as plt
import seaborn as sb
import numpy as np

fin_name = input('Data file name(*.csv) = ')
with open(fin_name, 'r') as f:
    data = [v for v in csv.reader(f)]

fout_name = input('Output file name(*.txt) = ')
fout = open(fout_name, 'w')
fout.write('Data file name = {}\n'.format(fin_name))

print('data = \n', data)

N = len(data) - 1
M = len(data[0]) - 1
Items = []
for j in range(M):
    Items.append(data[0][j + 1])
X = np.empty((N, M), dtype = int)
CaseID = []
for i in range(1, N + 1):
    CaseID.append(data[i][0])
    for j in range(M):
        X[i - 1][j] = int(data[i][j + 1])
 
print('X =')
fout.write('\nX =\n')
i = 0
for v in X:
    print(CaseID[i], ' ',end = '')
    fout.write('{} '.format(CaseID[i]))
    i += 1
    print(v)
    fout.write('{}\n'.format(v))
N = len(X)
print('N = ', N)
fout.write('\nN = {}\n'.format(N))
M = len(X[0])
print('M = ', M)
fout.write('M = {}\n'.format(M))

#raise Exception()

NStg = int(input('Number of stages = '))
print('NStg = ', NStg)

a = np.ones(NStg + 1)
 
stan_data = {'N': N, 'M': M, 'NStg': NStg, 'X': X, 'a': a}
 
sm = pystan.StanModel(file = 'IRTLatentClass.stan')
 
fit = sm.sampling(data = stan_data, n_jobs = 1)

p_samples = fit['p']
 
p_item_stage = np.empty((M, NStg))
for i in range(M):
    for s in range(NStg):
        p_item_stage[i][s] = p_samples[:,i,s].mean()
 
print('\n\nP(correct|item,stage)\n')
fout.write('\n\nP(correct|item,stage)\n\n')
print('{0:>7s}'.format('Item'), end = '')
fout.write('{0:>7s}'.format('Item'))
for j in range(NStg):
    print('{0:>9s}'.format('Stage-{}'.format(j)), end = '')
    fout.write('{0:>9s}'.format('Stage-{}'.format(j)))
print()
fout.write('\n')

for i in range(M):
    print('{0:>7s}'.format(Items[i]), end = '')
    fout.write('{0:>7s}'.format(Items[i]))
    for s in range(NStg):
        print('{0:>9.5f}'.format(p_item_stage[i][s]), end = '')
        fout.write('{0:>9.5f}'.format(p_item_stage[i][s]))
    print(' ')
    fout.write('\n')
 
theta = fit['theta']
p_stage = np.empty((N, NStg))
for j in range(N):
    for s in range(NStg):
        p_stage[j][s] = theta[:,j,s].mean()
 
print('\n\nP(stage|person)\n')
fout.write('\n\nP(stage|person)\n\n')
print('{0:>10s}'.format('Person'), end = '')
fout.write('{0:>10s}'.format('Person'))
for s in range(NStg):
    print('{0:>9s}'.format('Stage-{}'.format(s)), end = '')
    fout.write('{0:>9s}'.format('Stage-{}'.format(s)))
print()
fout.write('\n')
for j in range(N):
    print('{0:>10s}'.format(CaseID[j]), end = '')
    fout.write('{0:>10s}'.format(CaseID[j]))
    for s in range(NStg):
        print('{0:>9.5f}'.format(p_stage[j][s]), end = '')
        fout.write('{0:>9.5f}'.format(p_stage[j][s]))
    print(' ')
    fout.write('\n')
 
fout.close()
print('\nOutput file name =', fout_name)
